'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _desc, _value, _class;

var _decko = require('decko');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

// Taken from https://github.com/d4nyll/lethargy,adapted
// for use as an ES6 module, with support for horizontal scrolling added
var Lethargy = (_class = function () {
  /**
   * @param {Number} stability
   * @param {Number} sensitivity
   * @param {Number} tolerance
   * @param {Number} delay
   */
  function Lethargy(stability, sensitivity, tolerance, delay) {
    _classCallCheck(this, Lethargy);

    this.stability = stability != null ? Math.abs(stability) : 8;
    this.sensitivity = sensitivity != null ? 1 + Math.abs(sensitivity) : 120;
    this.tolerance = tolerance != null ? 1 + Math.abs(tolerance) : 1.05;
    this.delay = delay != null ? delay : 150;
    this.lastUpDeltas = function () {
      var i, ref, results;
      results = [];
      for (i = 1, ref = this.stability * 2; ref >= 1 ? i <= ref : i >= ref; ref >= 1 ? i++ : i--) {
        results.push(null);
      }
      return results;
    }.call(this);
    this.lastDownDeltas = function () {
      var i, ref, results;
      results = [];
      for (i = 1, ref = this.stability * 2; ref >= 1 ? i <= ref : i >= ref; ref >= 1 ? i++ : i--) {
        results.push(null);
      }
      return results;
    }.call(this);
    this.deltasTimestamp = function () {
      var i, ref, results;
      results = [];
      for (i = 1, ref = this.stability * 2; ref >= 1 ? i <= ref : i >= ref; ref >= 1 ? i++ : i--) {
        results.push(null);
      }
      return results;
    }.call(this);
  }

  /**
   * @param {MouseEvent} e
   */


  _createClass(Lethargy, [{
    key: 'check',
    value: function check(e) {
      var vertical = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      var lastDelta;
      e = e.originalEvent || e;
      if (e.wheelDelta != null) {
        lastDelta = e.wheelDelta;
      } else if (vertical && e.deltaY != null) {
        lastDelta = e.deltaY * -40;
      } else if (!vertical && e.deltaX != null) {
        lastDelta = e.deltaX * -40;
      } else if (e.detail != null || e.detail === 0) {
        lastDelta = e.detail * -40;
      }
      this.deltasTimestamp.push(Date.now());
      this.deltasTimestamp.shift();
      if (lastDelta > 0) {
        this.lastUpDeltas.push(lastDelta);
        this.lastUpDeltas.shift();
        return this.isInertia(1);
      } else {
        this.lastDownDeltas.push(lastDelta);
        this.lastDownDeltas.shift();
        return this.isInertia(-1);
      }
    }

    /**
     * @param {Number} direction
     */

  }, {
    key: 'isInertia',
    value: function isInertia(direction) {
      var lastDeltas, lastDeltasNew, lastDeltasOld, newAverage, newSum, oldAverage, oldSum;
      lastDeltas = direction === -1 ? this.lastDownDeltas : this.lastUpDeltas;
      if (lastDeltas[0] === null) {
        return direction;
      }
      if (this.deltasTimestamp[this.stability * 2 - 2] + this.delay > Date.now() && lastDeltas[0] === lastDeltas[this.stability * 2 - 1]) {
        return false;
      }
      lastDeltasOld = lastDeltas.slice(0, this.stability);
      lastDeltasNew = lastDeltas.slice(this.stability, this.stability * 2);
      oldSum = lastDeltasOld.reduce(function (t, s) {
        return t + s;
      });
      newSum = lastDeltasNew.reduce(function (t, s) {
        return t + s;
      });
      oldAverage = oldSum / lastDeltasOld.length;
      newAverage = newSum / lastDeltasNew.length;
      if (Math.abs(oldAverage) < Math.abs(newAverage * this.tolerance) && this.sensitivity < Math.abs(newAverage)) {
        return direction;
      } else {
        return false;
      }
    }

    /**
     *
     */

  }, {
    key: 'showLastUpDeltas',
    value: function showLastUpDeltas() {
      return this.lastUpDeltas;
    }

    /**
     *
     */

  }, {
    key: 'showLastDownDeltas',
    value: function showLastDownDeltas() {
      return this.lastDownDeltas;
    }
  }]);

  return Lethargy;
}(), (_applyDecoratedDescriptor(_class.prototype, 'check', [_decko.bind], Object.getOwnPropertyDescriptor(_class.prototype, 'check'), _class.prototype)), _class);
exports.default = Lethargy;